diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/zigbee/model/zigbee-stack.cc ns-3.44/src/zigbee/model/zigbee-stack.cc
--- ns-3.43/src/zigbee/model/zigbee-stack.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/zigbee/model/zigbee-stack.cc	2025-03-09 16:55:49.823372800 -0700
@@ -0,0 +1,152 @@
+/*
+ * Copyright (c) 2024 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#include "zigbee-stack.h"
+
+#include "ns3/channel.h"
+#include "ns3/log.h"
+#include "ns3/node.h"
+#include "ns3/packet.h"
+#include "ns3/pointer.h"
+#include "ns3/simulator.h"
+
+using namespace ns3::lrwpan;
+
+namespace ns3
+{
+namespace zigbee
+{
+NS_LOG_COMPONENT_DEFINE("ZigbeeStack");
+NS_OBJECT_ENSURE_REGISTERED(ZigbeeStack);
+
+TypeId
+ZigbeeStack::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::zigbee::ZigbeeStack")
+                            .SetParent<Object>()
+                            .SetGroupName("Zigbee")
+                            .AddConstructor<ZigbeeStack>();
+    return tid;
+}
+
+ZigbeeStack::ZigbeeStack()
+{
+    NS_LOG_FUNCTION(this);
+
+    m_nwk = CreateObject<zigbee::ZigbeeNwk>();
+    // TODO: Create  APS layer here.
+    //  m_aps = CreateObject<zigbee::ZigbeeAps> ();
+}
+
+ZigbeeStack::~ZigbeeStack()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+void
+ZigbeeStack::DoDispose()
+{
+    NS_LOG_FUNCTION(this);
+
+    m_netDevice = nullptr;
+    m_node = nullptr;
+    m_nwk = nullptr;
+    m_mac = nullptr;
+    Object::DoDispose();
+}
+
+void
+ZigbeeStack::DoInitialize()
+{
+    NS_LOG_FUNCTION(this);
+
+    AggregateObject(m_nwk);
+
+    NS_ABORT_MSG_UNLESS(m_netDevice,
+                        "Invalid NetDevice found when attempting to install ZigbeeStack");
+
+    // Make sure the NetDevice is previously initialized
+    // before using ZigbeeStack
+    m_netDevice->Initialize();
+
+    m_mac = m_netDevice->GetObject<lrwpan::LrWpanMacBase>();
+    NS_ABORT_MSG_UNLESS(m_mac,
+                        "No valid LrWpanMacBase found in this NetDevice, cannot use ZigbeeStack");
+
+    // Set NWK callback hooks with the MAC
+    m_nwk->SetMac(m_mac);
+    m_mac->SetMcpsDataIndicationCallback(MakeCallback(&ZigbeeNwk::McpsDataIndication, m_nwk));
+    m_mac->SetMlmeOrphanIndicationCallback(MakeCallback(&ZigbeeNwk::MlmeOrphanIndication, m_nwk));
+    m_mac->SetMlmeCommStatusIndicationCallback(
+        MakeCallback(&ZigbeeNwk::MlmeCommStatusIndication, m_nwk));
+    m_mac->SetMlmeBeaconNotifyIndicationCallback(
+        MakeCallback(&ZigbeeNwk::MlmeBeaconNotifyIndication, m_nwk));
+    m_mac->SetMlmeAssociateIndicationCallback(
+        MakeCallback(&ZigbeeNwk::MlmeAssociateIndication, m_nwk));
+    m_mac->SetMcpsDataConfirmCallback(MakeCallback(&ZigbeeNwk::McpsDataConfirm, m_nwk));
+    m_mac->SetMlmeScanConfirmCallback(MakeCallback(&ZigbeeNwk::MlmeScanConfirm, m_nwk));
+    m_mac->SetMlmeStartConfirmCallback(MakeCallback(&ZigbeeNwk::MlmeStartConfirm, m_nwk));
+    m_mac->SetMlmeSetConfirmCallback(MakeCallback(&ZigbeeNwk::MlmeSetConfirm, m_nwk));
+    m_mac->SetMlmeGetConfirmCallback(MakeCallback(&ZigbeeNwk::MlmeGetConfirm, m_nwk));
+    m_mac->SetMlmeAssociateConfirmCallback(MakeCallback(&ZigbeeNwk::MlmeAssociateConfirm, m_nwk));
+    // TODO: complete other callback hooks with the MAC
+
+    // Obtain Extended address as soon as NWK is set to begin operations
+    m_mac->MlmeGetRequest(MacPibAttributeIdentifier::macExtendedAddress);
+
+    // TODO: Set APS callback hooks with NWK when support for APS layer is added.
+    //       For example:
+    // m_aps->SetNwk (m_nwk);
+    // m_nwk->SetNldeDataIndicationCallback (MakeCallback (&ZigbeeAps::NldeDataIndication, m_aps));
+
+    Object::DoInitialize();
+}
+
+Ptr<Channel>
+ZigbeeStack::GetChannel() const
+{
+    return m_netDevice->GetChannel();
+}
+
+Ptr<Node>
+ZigbeeStack::GetNode() const
+{
+    return m_node;
+}
+
+Ptr<NetDevice>
+ZigbeeStack::GetNetDevice() const
+{
+    return m_netDevice;
+}
+
+void
+ZigbeeStack::SetNetDevice(Ptr<NetDevice> netDevice)
+{
+    NS_LOG_FUNCTION(this << netDevice);
+    m_netDevice = netDevice;
+    m_node = m_netDevice->GetNode();
+}
+
+Ptr<zigbee::ZigbeeNwk>
+ZigbeeStack::GetNwk() const
+{
+    return m_nwk;
+}
+
+void
+ZigbeeStack::SetNwk(Ptr<zigbee::ZigbeeNwk> nwk)
+{
+    NS_LOG_FUNCTION(this);
+    NS_ABORT_MSG_IF(ZigbeeStack::IsInitialized(), "NWK layer cannot be set after initialization");
+    m_nwk = nwk;
+}
+
+} // namespace zigbee
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/zigbee/model/zigbee-stack.h ns-3.44/src/zigbee/model/zigbee-stack.h
--- ns-3.43/src/zigbee/model/zigbee-stack.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/zigbee/model/zigbee-stack.h	2025-03-09 16:55:49.823372800 -0700
@@ -0,0 +1,124 @@
+/*
+ * Copyright (c) 2024 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#ifndef ZIGBEE_STACK_H
+#define ZIGBEE_STACK_H
+
+#include "zigbee-nwk.h"
+
+#include "ns3/lr-wpan-mac-base.h"
+#include "ns3/lr-wpan-net-device.h"
+#include "ns3/traced-callback.h"
+
+#include <stdint.h>
+#include <string>
+
+namespace ns3
+{
+
+class Node;
+
+namespace zigbee
+{
+
+class ZigbeeNwk;
+
+/**
+ * @ingroup zigbee
+ *
+ *  Zigbee protocol stack to device interface.
+ *
+ * This class is an encapsulating class representing the protocol stack as described
+ * by the Zigbee Specification. In the current implementation only the Zigbee
+ * network layer (NWK) is included. However, this class is meant be later
+ * be extended to include other layer and sublayers part of the Zigbee Specification.
+ * The implementation is analogous to a NetDevice which encapsulates PHY and
+ * MAC layers and provide the necessary hooks. Zigbee Stack is meant to encapsulate
+ * NWK, APS, ZLC layers (and others if applicable).
+ */
+class ZigbeeStack : public Object
+{
+  public:
+    /**
+     * Get the type ID.
+     *
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * Default constructor
+     */
+    ZigbeeStack();
+    ~ZigbeeStack() override;
+
+    /**
+     * Get the Channel object of the underlying LrWpanNetDevice
+     * @return The LrWpanNetDevice Channel Object
+     */
+    Ptr<Channel> GetChannel() const;
+
+    /**
+     * Get the node currently using this ZigbeeStack.
+     * @return The reference to the node object using this ZigbeeStack.
+     */
+    Ptr<Node> GetNode() const;
+
+    /**
+     * Get the NWK layer used by this ZigbeeStack.
+     *
+     * @return the NWK object
+     */
+    Ptr<ZigbeeNwk> GetNwk() const;
+
+    /**
+     * Set the NWK layer used by this ZigbeeStack.
+     *
+     * @param nwk The NWK layer object
+     */
+    void SetNwk(Ptr<ZigbeeNwk> nwk);
+
+    /**
+     *  Returns a smart pointer to the underlying NetDevice.
+     *
+     * @return A smart pointer to the underlying NetDevice.
+     */
+    Ptr<NetDevice> GetNetDevice() const;
+
+    /**
+     * Setup Zigbee to be the next set of higher layers for the specified NetDevice.
+     * All the packets incoming and outgoing from the NetDevice will be
+     * processed by ZigbeeStack.
+     *
+     * @param netDevice A smart pointer to the NetDevice used by Zigbee.
+     */
+    void SetNetDevice(Ptr<NetDevice> netDevice);
+
+  protected:
+    /**
+     * Dispose of the Objects used by the ZigbeeStack
+     */
+    void DoDispose() override;
+
+    /**
+     * Initialize of the Objects used by the ZigbeeStack
+     */
+    void DoInitialize() override;
+
+  private:
+    Ptr<lrwpan::LrWpanMacBase> m_mac; //!< The underlying LrWpan MAC connected to this Zigbee Stack.
+    Ptr<ZigbeeNwk> m_nwk;             //!< The Zigbee Network layer.
+    Ptr<Node> m_node;                 //!< The node associated with this NetDevice.
+    Ptr<NetDevice> m_netDevice;       //!< Smart pointer to the underlying NetDevice.
+};
+
+} // namespace zigbee
+} // namespace ns3
+
+#endif /* ZIGBEE_STACK_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/zigbee/test/zigbee-rreq-test.cc ns-3.44/src/zigbee/test/zigbee-rreq-test.cc
--- ns-3.43/src/zigbee/test/zigbee-rreq-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/zigbee/test/zigbee-rreq-test.cc	2025-03-09 16:55:49.823372800 -0700
@@ -0,0 +1,376 @@
+/*
+ * Copyright (c) 2024 Tokushima University, Tokushima, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#include "ns3/constant-position-mobility-model.h"
+#include "ns3/core-module.h"
+#include "ns3/log.h"
+#include "ns3/lr-wpan-module.h"
+#include "ns3/packet.h"
+#include "ns3/propagation-delay-model.h"
+#include "ns3/propagation-loss-model.h"
+#include "ns3/rng-seed-manager.h"
+#include "ns3/simulator.h"
+#include "ns3/single-model-spectrum-channel.h"
+#include "ns3/zigbee-module.h"
+
+#include <iomanip>
+#include <iostream>
+
+using namespace ns3;
+using namespace ns3::lrwpan;
+using namespace ns3::zigbee;
+
+NS_LOG_COMPONENT_DEFINE("zigbee-rreq-test");
+
+/**
+ * @ingroup zigbee-test
+ * @ingroup tests
+ *
+ * Zigbee RREQ transmission retries test case
+ */
+class ZigbeeRreqRetryTestCase : public TestCase
+{
+  public:
+    ZigbeeRreqRetryTestCase();
+    ~ZigbeeRreqRetryTestCase() override;
+
+  private:
+    /**
+     * Called in response to a NLME-NETWORK-DISCOVERY.request
+     *
+     * @param testcase The pointer to the testcase
+     * @param stack The zigbee stack of the device originating the callback
+     * @param params The NLME-NETWORK-DISCOVERY.confirm parameters
+     */
+    static void NwkNetworkDiscoveryConfirm(ZigbeeRreqRetryTestCase* testcase,
+                                           Ptr<ZigbeeStack> stack,
+                                           NlmeNetworkDiscoveryConfirmParams params);
+
+    /**
+     * Called in response to a NLME-JOIN.request
+     *
+     * @param testcase The pointer to the testcase
+     * @param stack The zigbee stack of the device originating the callback
+     * @param params The NLME-JOIN.confirm parameters
+     */
+    static void NwkJoinConfirm(ZigbeeRreqRetryTestCase* testcase,
+                               Ptr<ZigbeeStack> stack,
+                               NlmeJoinConfirmParams params);
+
+    /**
+     * Called when a maximum RREQ retries are reached
+     *
+     * @param testcase The pointer to the testcase
+     * @param stack The zigbee stack of the device originating the callback
+     * @param rreqid The RREQ ID
+     * @param dst The destination Mac16Address of the RREQ
+     * @param rreqRetriesNum Maximum number of retries reached
+     */
+    static void RreqRetriesExhausted(ZigbeeRreqRetryTestCase* testcase,
+                                     Ptr<ZigbeeStack> stack,
+                                     uint8_t rreqid,
+                                     Mac16Address dst,
+                                     uint8_t rreqRetriesNum);
+    void DoRun() override;
+
+    std::vector<std::pair<uint32_t, uint32_t>>
+        m_rreqRetriesExhaustedList; //!< A list containing
+                                    //!< the RREQ ID and the allowed max retries every time the
+                                    //!< maximum RREQ retries are reached
+};
+
+ZigbeeRreqRetryTestCase::ZigbeeRreqRetryTestCase()
+    : TestCase("Zigbee: RREQ retries test")
+{
+}
+
+ZigbeeRreqRetryTestCase::~ZigbeeRreqRetryTestCase()
+{
+}
+
+void
+ZigbeeRreqRetryTestCase::NwkNetworkDiscoveryConfirm(ZigbeeRreqRetryTestCase* testcase,
+                                                    Ptr<ZigbeeStack> stack,
+                                                    NlmeNetworkDiscoveryConfirmParams params)
+{
+    // See Zigbee Specification r22.1.0, 3.6.1.4.1
+    // This method implements a simplistic version of the method implemented
+    // in a zigbee APL layer. In this layer a candidate Extended PAN Id must
+    // be selected and a NLME-JOIN.request must be issued.
+
+    if (params.m_status == NwkStatus::SUCCESS)
+    {
+        std::cout << " Network discovery confirm Received. Networks found ("
+                  << params.m_netDescList.size() << "):\n";
+
+        for (const auto& netDescriptor : params.m_netDescList)
+        {
+            std::cout << " ExtPanID: 0x" << std::hex << netDescriptor.m_extPanId << "\n"
+                      << std::dec << " CH:  " << static_cast<uint32_t>(netDescriptor.m_logCh)
+                      << "\n"
+                      << std::hex << " Pan ID: 0x" << netDescriptor.m_panId << "\n"
+                      << " Stack profile: " << std::dec
+                      << static_cast<uint32_t>(netDescriptor.m_stackProfile) << "\n"
+                      << "--------------------\n";
+        }
+
+        NlmeJoinRequestParams joinParams;
+
+        zigbee::CapabilityInformation capaInfo;
+        capaInfo.SetDeviceType(ROUTER);
+        capaInfo.SetAllocateAddrOn(true);
+
+        joinParams.m_rejoinNetwork = zigbee::JoiningMethod::ASSOCIATION;
+        joinParams.m_capabilityInfo = capaInfo.GetCapability();
+        joinParams.m_extendedPanId = params.m_netDescList[0].m_extPanId;
+
+        Simulator::ScheduleNow(&ZigbeeNwk::NlmeJoinRequest, stack->GetNwk(), joinParams);
+    }
+    else
+    {
+        NS_ABORT_MSG("Unable to discover networks | status: " << params.m_status);
+    }
+}
+
+void
+ZigbeeRreqRetryTestCase::NwkJoinConfirm(ZigbeeRreqRetryTestCase* testcase,
+                                        Ptr<ZigbeeStack> stack,
+                                        NlmeJoinConfirmParams params)
+{
+    if (params.m_status == NwkStatus::SUCCESS)
+    {
+        std::cout << Simulator::Now().As(Time::S)
+                  << " The device joined the network SUCCESSFULLY with short address " << std::hex
+                  << params.m_networkAddress << " on the Extended PAN Id: " << std::hex
+                  << params.m_extendedPanId << "\n"
+                  << std::dec;
+
+        // 3 - After dev 1 is associated, it should be started as a router
+        //     (i.e. it becomes able to accept request from other devices to join the network)
+        NlmeStartRouterRequestParams startRouterParams;
+        Simulator::ScheduleNow(&ZigbeeNwk::NlmeStartRouterRequest,
+                               stack->GetNwk(),
+                               startRouterParams);
+    }
+    else
+    {
+        std::cout << " The device FAILED to join the network with status " << params.m_status
+                  << "\n";
+    }
+}
+
+void
+ZigbeeRreqRetryTestCase::RreqRetriesExhausted(ZigbeeRreqRetryTestCase* testcase,
+                                              Ptr<ZigbeeStack> stack,
+                                              uint8_t rreqid,
+                                              Mac16Address dst,
+                                              uint8_t rreqRetriesNum)
+{
+    NS_LOG_DEBUG("RREQ retries (" << static_cast<uint32_t>(rreqRetriesNum)
+                                  << ") exhausted for destination [" << dst << "] and RREQ ID "
+                                  << static_cast<uint32_t>(rreqid));
+
+    testcase->m_rreqRetriesExhaustedList.emplace_back(
+        std::pair(stack->GetNode()->GetId(), rreqRetriesNum));
+}
+
+void
+ZigbeeRreqRetryTestCase::DoRun()
+{
+    // RREQ retries exhaustion test
+    // This test verifies that the necessary number of Route Requests are issued during
+    // zigbee's route discovery process in which a Route Reply (RREP) is not received.
+    // In this test, a coordinator and 2 routers are set in a line.
+    // The coordinator issues a route discovery primitive (NLME-ROUTE-DISCOVERY.request)
+    // to a non-existent destination (0d:10). Route request are retried a number of times
+    // depending on the origin of the request (initial request or relayed request)
+    //   Topology:
+    //
+    //     ========= RREQ(x3) =====>    ======== RREQ(x2) ===>     ==== RREQ(x2) ====>
+    //  ZC--------------------------ZR1-------------------------ZR2
+    // (Node 0)                   (Node 1)                    (Node 2)
+    //
+    // The number of retries depend on the NWK layer constants:
+    // nwkcInitialRREQRetries (Default: 3)
+    // nwkcRREQRetries (Default: 2)
+
+    LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC | LOG_PREFIX_NODE));
+    LogComponentEnable("zigbee-rreq-test", LOG_LEVEL_DEBUG);
+
+    RngSeedManager::SetSeed(3);
+    RngSeedManager::SetRun(4);
+
+    NodeContainer nodes;
+    nodes.Create(3);
+
+    //// Configure MAC
+
+    LrWpanHelper lrWpanHelper;
+    NetDeviceContainer lrwpanDevices = lrWpanHelper.Install(nodes);
+    Ptr<LrWpanNetDevice> dev0 = lrwpanDevices.Get(0)->GetObject<LrWpanNetDevice>();
+    Ptr<LrWpanNetDevice> dev1 = lrwpanDevices.Get(1)->GetObject<LrWpanNetDevice>();
+    Ptr<LrWpanNetDevice> dev2 = lrwpanDevices.Get(2)->GetObject<LrWpanNetDevice>();
+
+    dev0->GetMac()->SetExtendedAddress("00:00:00:00:00:00:CA:FE");
+    dev1->GetMac()->SetExtendedAddress("00:00:00:00:00:00:00:01");
+    dev2->GetMac()->SetExtendedAddress("00:00:00:00:00:00:00:02");
+
+    Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
+    Ptr<LogDistancePropagationLossModel> propModel =
+        CreateObject<LogDistancePropagationLossModel>();
+
+    Ptr<ConstantSpeedPropagationDelayModel> delayModel =
+        CreateObject<ConstantSpeedPropagationDelayModel>();
+
+    channel->AddPropagationLossModel(propModel);
+    channel->SetPropagationDelayModel(delayModel);
+
+    dev0->SetChannel(channel);
+    dev1->SetChannel(channel);
+    dev2->SetChannel(channel);
+
+    //// Configure NWK
+
+    ZigbeeHelper zigbee;
+    ZigbeeStackContainer zigbeeStackContainer = zigbee.Install(lrwpanDevices);
+
+    Ptr<ZigbeeStack> zstack0 = zigbeeStackContainer.Get(0)->GetObject<ZigbeeStack>();
+    Ptr<ZigbeeStack> zstack1 = zigbeeStackContainer.Get(1)->GetObject<ZigbeeStack>();
+    Ptr<ZigbeeStack> zstack2 = zigbeeStackContainer.Get(2)->GetObject<ZigbeeStack>();
+
+    //// Configure Nodes Mobility
+
+    Ptr<ConstantPositionMobilityModel> dev0Mobility = CreateObject<ConstantPositionMobilityModel>();
+    dev0Mobility->SetPosition(Vector(0, 0, 0));
+    dev0->GetPhy()->SetMobility(dev0Mobility);
+
+    Ptr<ConstantPositionMobilityModel> dev1Mobility = CreateObject<ConstantPositionMobilityModel>();
+    dev1Mobility->SetPosition(Vector(90, 0, 0)); // 110 ,0,0
+    dev1->GetPhy()->SetMobility(dev1Mobility);
+
+    Ptr<ConstantPositionMobilityModel> dev2Mobility = CreateObject<ConstantPositionMobilityModel>();
+    dev2Mobility->SetPosition(Vector(170, 0, 0)); // 190,0,0
+    dev2->GetPhy()->SetMobility(dev2Mobility);
+
+    // NWK callbacks hooks, these hooks are usually directly connected to the APS layer
+    // where all these calls inform the result of a request originated the APS layer.
+    // In this test these are used to complete the Join process and router initialization
+    zstack1->GetNwk()->SetNlmeNetworkDiscoveryConfirmCallback(
+        MakeBoundCallback(&ZigbeeRreqRetryTestCase::NwkNetworkDiscoveryConfirm, this, zstack1));
+    zstack2->GetNwk()->SetNlmeNetworkDiscoveryConfirmCallback(
+        MakeBoundCallback(&ZigbeeRreqRetryTestCase::NwkNetworkDiscoveryConfirm, this, zstack2));
+
+    zstack1->GetNwk()->SetNlmeJoinConfirmCallback(
+        MakeBoundCallback(&ZigbeeRreqRetryTestCase::NwkJoinConfirm, this, zstack1));
+    zstack2->GetNwk()->SetNlmeJoinConfirmCallback(
+        MakeBoundCallback(&ZigbeeRreqRetryTestCase::NwkJoinConfirm, this, zstack2));
+
+    // Connect to traces in the NWK layer
+    zstack0->GetNwk()->TraceConnectWithoutContext(
+        "rreqRetriesExhausted",
+        MakeBoundCallback(&ZigbeeRreqRetryTestCase::RreqRetriesExhausted, this, zstack0));
+
+    zstack1->GetNwk()->TraceConnectWithoutContext(
+        "rreqRetriesExhausted",
+        MakeBoundCallback(&ZigbeeRreqRetryTestCase::RreqRetriesExhausted, this, zstack1));
+
+    zstack2->GetNwk()->TraceConnectWithoutContext(
+        "rreqRetriesExhausted",
+        MakeBoundCallback(&ZigbeeRreqRetryTestCase::RreqRetriesExhausted, this, zstack2));
+
+    // 1 - Initiate the Zigbee coordinator, start the network
+    NlmeNetworkFormationRequestParams netFormParams;
+    netFormParams.m_scanChannelList.channelPageCount = 1;
+    netFormParams.m_scanChannelList.channelsField[0] = ALL_CHANNELS;
+    netFormParams.m_scanDuration = 0;
+    netFormParams.m_superFrameOrder = 15;
+    netFormParams.m_beaconOrder = 15;
+
+    Simulator::ScheduleWithContext(zstack0->GetNode()->GetId(),
+                                   Seconds(1),
+                                   &ZigbeeNwk::NlmeNetworkFormationRequest,
+                                   zstack0->GetNwk(),
+                                   netFormParams);
+
+    // 2- Let the dev1 (Router) discovery the coordinator and join the network, after
+    //    this, it will become router itself(call to NLME-START-ROUTER.request). We
+    //    continue doing the same with the rest of the devices which will discover the
+    //    previously added routers and join the network
+    NlmeNetworkDiscoveryRequestParams netDiscParams;
+    netDiscParams.m_scanChannelList.channelPageCount = 1;
+    netDiscParams.m_scanChannelList.channelsField[0] = 0x00007800; // 0x00000800;
+    netDiscParams.m_scanDuration = 2;
+    Simulator::ScheduleWithContext(zstack1->GetNode()->GetId(),
+                                   Seconds(3),
+                                   &ZigbeeNwk::NlmeNetworkDiscoveryRequest,
+                                   zstack1->GetNwk(),
+                                   netDiscParams);
+
+    NlmeNetworkDiscoveryRequestParams netDiscParams2;
+    netDiscParams2.m_scanChannelList.channelPageCount = 1;
+    netDiscParams2.m_scanChannelList.channelsField[0] = 0x00007800; // 0x00000800;
+    netDiscParams2.m_scanDuration = 2;
+    Simulator::ScheduleWithContext(zstack2->GetNode()->GetId(),
+                                   Seconds(4),
+                                   &ZigbeeNwk::NlmeNetworkDiscoveryRequest,
+                                   zstack2->GetNwk(),
+                                   netDiscParams2);
+
+    // 5- Find a route to the given device short address
+    NlmeRouteDiscoveryRequestParams routeDiscParams;
+    routeDiscParams.m_dstAddr = Mac16Address("0d:10");
+    Simulator::ScheduleWithContext(zstack0->GetNode()->GetId(),
+                                   Seconds(8),
+                                   &ZigbeeNwk::NlmeRouteDiscoveryRequest,
+                                   zstack0->GetNwk(),
+                                   routeDiscParams);
+    Simulator::Run();
+
+    for (auto rreqRetriesExhaustedElement : m_rreqRetriesExhaustedList)
+    {
+        if (rreqRetriesExhaustedElement.first == 0)
+        {
+            // For Node with id 0 (Coordinator/RREQ originator) the number of retries is
+            // nwkcInitialRREQRetries (Default: 3)
+            NS_TEST_EXPECT_MSG_EQ(rreqRetriesExhaustedElement.second,
+                                  3,
+                                  "The number of RREQ retries from an originator should be 3");
+        }
+        else
+        {
+            // For other node other that the RREQ originator the number of retries is
+            // nwkcRREQRetries (Default: 2)
+            NS_TEST_EXPECT_MSG_EQ(rreqRetriesExhaustedElement.second,
+                                  2,
+                                  "The number of RREQ retries from a relaying node should be 2");
+        }
+    }
+
+    Simulator::Destroy();
+}
+
+/**
+ * @ingroup zigbee-test
+ * @ingroup tests
+ *
+ * Zigbee RREQ TestSuite
+ */
+class ZigbeeRreqTestSuite : public TestSuite
+{
+  public:
+    ZigbeeRreqTestSuite();
+};
+
+ZigbeeRreqTestSuite::ZigbeeRreqTestSuite()
+    : TestSuite("zigbee-rreq-test", Type::UNIT)
+{
+    AddTestCase(new ZigbeeRreqRetryTestCase, TestCase::Duration::QUICK);
+}
+
+static ZigbeeRreqTestSuite zigbeeRreqTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/test.py ns-3.44/test.py
--- ns-3.43/test.py	2024-10-09 16:41:10.148656800 -0700
+++ ns-3.44/test.py	2025-03-09 16:55:49.823372800 -0700
@@ -142,7 +142,14 @@
 ):
     # Look for the examples-to-run file exists.
     if not os.path.exists(examples_to_run_path):
-        return
+        # Also tests for contribs OUTSIDE the ns-3-dev directory
+        possible_external_contrib_path = examples_to_run_path.replace(
+            "contrib", f"{os.path.dirname(os.path.dirname(__file__))}/ns-3-external-contrib"
+        )
+        if os.path.exists(possible_external_contrib_path):
+            examples_to_run_path = possible_external_contrib_path
+        else:
+            return
 
     # Each tuple in the C++ list of examples to run contains
     #
@@ -1246,7 +1253,7 @@
             build_cmd = "./ns3"
 
         if sys.platform == "win32":
-            build_cmd = sys.executable + " " + build_cmd
+            build_cmd = f'"{sys.executable}" {build_cmd}'
 
         if args.verbose:
             print("Building: %s" % build_cmd)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/utils/bench-packets.cc ns-3.44/utils/bench-packets.cc
--- ns-3.43/utils/bench-packets.cc	2024-10-09 16:41:10.148656800 -0700
+++ ns-3.44/utils/bench-packets.cc	2025-03-09 16:55:49.823372800 -0700
@@ -35,13 +35,13 @@
      * deserialization was correct.  If Deserialize() has not yet been
      * called on the header, will return false.
      *
-     * \returns true if success, false if failed or if deserialization not tried
+     * @returns true if success, false if failed or if deserialization not tried
      */
     bool IsOk() const;
 
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
     TypeId GetInstanceTypeId() const override;
@@ -53,7 +53,7 @@
   private:
     /**
      * Get type name function
-     * \returns the type name string
+     * @returns the type name string
      */
     static std::string GetTypeName();
     bool m_ok; ///< variable to track whether deserialization succeeded
@@ -143,7 +143,7 @@
   public:
     /**
      * Get the bench tag name.
-     * \return the name.
+     * @return the name.
      */
     static std::string GetName()
     {
@@ -154,7 +154,7 @@
 
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId()
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/utils/bench-scheduler.cc ns-3.44/utils/bench-scheduler.cc
--- ns-3.43/utils/bench-scheduler.cc	2024-10-09 16:41:10.148656800 -0700
+++ ns-3.44/utils/bench-scheduler.cc	2025-03-09 16:55:49.823372800 -0700
@@ -49,8 +49,8 @@
   public:
     /**
      * Constructor
-     * \param [in] population The number of events to keep in the scheduler.
-     * \param [in] total The total number of events to execute.
+     * @param [in] population The number of events to keep in the scheduler.
+     * @param [in] total The total number of events to execute.
      */
     Bench(const uint64_t population, const uint64_t total)
         : m_population(population),
@@ -62,7 +62,7 @@
     /**
      * Set the event delay interval random stream.
      *
-     * \param [in] stream The random variable stream to be used to generate
+     * @param [in] stream The random variable stream to be used to generate
      *              delays for future events.
      */
     void SetRandomStream(Ptr<RandomVariableStream> stream)
@@ -73,7 +73,7 @@
     /**
      * Set the number of events to populate the scheduler with.
      * Each event executed schedules a new event, maintaining the population.
-     * \param [in] population The number of events to keep in the scheduler.
+     * @param [in] population The number of events to keep in the scheduler.
      */
     void SetPopulation(const uint64_t population)
     {
@@ -82,7 +82,7 @@
 
     /**
      * Set the total number of events to execute.
-     * \param [in] total The total number of events to execute.
+     * @param [in] total The total number of events to execute.
      */
     void SetTotal(const uint64_t total)
     {
@@ -101,7 +101,7 @@
     /**
      *  Run the benchmark as configured.
      *
-     * \returns The Result.
+     * @returns The Result.
      */
     Result Run();
 
@@ -176,12 +176,12 @@
      *
      * Output will be in the form of a table showing performance for each run.
      *
-     * \param [in] factory Factory pre-configured to create the desired Scheduler.
-     * \param [in] pop The event population size.
-     * \param [in] total The total number of events to execute.
-     * \param [in] runs The number of replications.
-     * \param [in] eventStream The random stream of event delays.
-     * \param [in] calRev For the CalendarScheduler, whether the Reverse attribute was set.
+     * @param [in] factory Factory pre-configured to create the desired Scheduler.
+     * @param [in] pop The event population size.
+     * @param [in] total The total number of events to execute.
+     * @param [in] runs The number of replications.
+     * @param [in] eventStream The random stream of event delays.
+     * @param [in] calRev For the CalendarScheduler, whether the Reverse attribute was set.
      */
     BenchSuite(ObjectFactory& factory,
                uint64_t pop,
@@ -213,16 +213,16 @@
         /**
          * Construct from the individual run result.
          *
-         * \param [in] r The result from a single run.
-         * \returns The run result.
+         * @param [in] r The result from a single run.
+         * @returns The run result.
          */
         static Result Bench(Bench::Result r);
 
         /**
          * Log this result.
          *
-         * \tparam T The type of the label.
-         * \param label The label for the line.
+         * @tparam T The type of the label.
+         * @param label The label for the line.
          */
         template <typename T>
         void Log(T label) const;
@@ -384,8 +384,8 @@
  *
  *  If the \p filename is `-` standard input will be used.
  *
- *  \param [in] filename The delay interval source file name.
- *  \returns The RandomVariableStream.
+ *  @param [in] filename The delay interval source file name.
+ *  @returns The RandomVariableStream.
  */
 Ptr<RandomVariableStream>
 GetRandomStream(std::string filename)
